// Modelo de estado del ascensor
clear;
close();
clc;
//Costantes del sistema
Ra=1.96;
La=0.01;
Kt=2.5;
Kw=2.38;
A=1;
J=5.4;
B=1275;
K=49000;
M=500;
Bm= .000000001;
N2=50;
N1=1;
r=0.3;
//Matrices del Sistema
A=[-Ra/La -Kw/La 0 0; Kt*N2^2/(N1^2*J) -B/J  -K*N2*r/(N1*J) 0; 0 r*N1/N2 0 -1; 0 0 K/M 0];
B=[1000; 0; 0; 0];
C=[0 0 0 1] ;
D=[0];
// Modelo de Estado
// Variables de Estado : [Ia Wm X V2]'
P1=syslin('c',A,B,C,D);
P1
// Cálculo de la Función de Transferencia
s=poly(0,"s");
Id=eye(4,4);
// Matriz detransición de Estados
Fi=s*Id-A
Pol_carac=det(Fi)
// Cálculo de Autovalores
Autov=roots(Pol_carac)
// Función de Transferncia
G1=C*Fi^-1*B;
G1=syslin("c",G1) // Para que sea considerada como transferencia
zpk(G1)
// Modelo para Simular
C2=eye(4,4);
D2=zeros(4,1);
P2=syslin('c',A,B,C2,D2);
P2
// Simulación
T=0:0.001:10; // Vector de Tiempos
Y1=csim('step',T,P2);
// Gráficos
plot(T',Y1(1,:)')
xgrid();
title('CORIENTE DEL MOTOR');
ylabel('Amp.');
figure(2);
plot(T',Y1(2,:)')
title('VELOCIDAD DEL MOTOR');
ylabel('rad/seg');
xgrid();
figure(3)
plot(T',Y1(3,:)')
title('ESTIRAMIENTO DE CABLE');
ylabel('M');
xgrid();
figure(4);
plot(T',Y1(4,:)')
title('VELOCIDAD DE LA CABINA');
ylabel('M/seg');
xgrid();
//
// Controlabilidad
U=cont_mat(A,B);
U
n=rank(U)
// Observabilidad 
V=obsv_mat(P1);
V
n=rank(V)
// Observabilidad si se mide Wm
V2=obsv_mat(A,C2(2,:));
V2
n=rank(V2)
